local L = AceLibrary("AceLocale-2.2"):new("Incubator")
local BB = AceLibrary("Babble-Boss-2.2")
local BZ = AceLibrary("Babble-Zone-2.2")
local surface = AceLibrary("Surface-1.0")
local dewdrop = AceLibrary("Dewdrop-2.0")
local AllowTimers = true
local InCombat = false
local INCUBATOR_OOC_THRESHOLD = 5
local RunningTimers = { }
local CurrentCombat = { }
local Killcount = { }
local LastOOC = 0
local anchor = "Incubator Anchor"
local BarCount = 0
local Lastexp = 0

local IncubatorTable = {
	-- Localized name = Respawn time in seconds, minimum count to start a timer, is grouped with other mobs, localized short name
	[L["Spectral Charger"]] 		= {1800, -1,	true,		L["Spectral Charger_Short"]},
	[L["Spectral Stallion"]] 		= {1800, -1,	true,		L["Spectral Stallion_Short"]},
	[L["Spectral Stable Hand"]] = {1800, -1,	true,		L["Spectral Stable Hand_Short"]},

	[L["Phantom Attendant"]] 		= {3600, -1,	false,		L["Phantom Attendant_Short"]},
	[L["Phantom Guest"]] 				= {3600,  8,	false,		L["Phantom Guest_Short"]},
	[L["Phantom Valet"]] 				= {3600, -1,	false,		L["Phantom Valet_Short"]}, 
	[L["Skeletal Waiter"]] 			= {3600, -1,	false,		L["Skeletal Waiter_Short"]},

	[L["Wanton Hostess"]] 			= {2700, -1,	true,		L["Wanton Hostess_Short"]},
	[L["Concubine"]] 						= {2700, -1,	true,		L["Concubine_Short"]},
	[L["Night Mistress"]] 			= {2700, -1,	true,		L["Night Mistress_Short"]},
	[L["Phantom Guardsman"]] 		= {2700,  2,	false,		L["Phantom Guardsman_Short"]},
	[L["Spectral Sentry"]] 			= {2700,  2,	false,		L["Spectral Sentry_Short"]},

	[L["Skeletal Usher"]] 			= {3600, -1,	false,		L["Skeletal Usher_Short"]},
	[L["Phantom Stagehand"]]		= {3600, -1,	false, 	L["Phantom Stagehand_Short"]},
	[L["Spectral Performer"]]		= {3600,  2,	false,		L["Spectral Performer_Short"]},
	
	[L["Arcane Anomaly"]]				=	{2700, -1,	true,		L["Arcane Anomaly_Short"]},
	[L["Syphoner"]]							= {2700,  5,	true,		L["Syphoner_Short"]},
	

	[L["Mana Feeder"]]					= {7200,  3,	true,		L["Mana Feeder_Short"]},
	[L["Chaotic Sentience"]]		=	{7200, -1,	true,		L["Chaotic Sentience_Short"]},
	[L["Mana Warp"]]						=	{7200,  2,	true,		L["Mana Warp_Short"]},
	[L["Magical Horror"]]				=	{7200, -1,	true,		L["Magical Horror_Short"]},
	[L["Arcane Watchman"]]			= {2700,  2,	false,		L["Arcane Watchman_Short"]},
	[L["Arcane Protector"]]			=	{7200, -1,	false,		L["Arcane Protector_Short"]},
	
	[L["Homunculus"]]						= {7200, -1,	true,		L["Homunculus_Short"]},
	[L["Shadow Pillager"]]			= {7200, -1,	true,		L["Shadow Pillager_Short"]},
	
	[L["Spell Shade"]]					= {7200, -1,	true,		L["Spell Shade_Short"]},
	[L["Sorcerous Shade"]]			= {7200, -1,	true,		L["Sorcerous Shade_Short"]},
	[L["Ethereal Thief"]]				=	{7200, -1, false,		L["Ethereal Thief_Short"]},
	[L["Ethereal Spellfilcher"]]={7200, -1, false,		L["Ethereal Spellfilcher_Short"]},

	[L["Fleshbeast"]]						=	{7200, 	2, false,		L["Fleshbeast_Short"]},
	[L["Greater Fleshbeast"]]		=	{7200, -1, false,		L["Greater Fleshbeast_Short"]},
		
	[L["Lair Brute"]]						= {3600, -1,	true,		L["Lair Brute_Short"]},
	[L["Gronn-Priest"]]					=	{3600, -1,	true,		L["Gronn-Priest_Short"]},
	
	[L["Hellfire Warder"]]			=	{3600, -1, false,		L["Hellfire Warder_Short"]},
	
	[L["Underbog Colossus"]]		=	{2400, -1, false,		L["Underbog Colossus_Short"]},
	[L["Coilfang Hate-Screamer"]]={2700, -1, true,		L["Coilfang Hate-Screamer_Short"]},
	[L["Coilfang Beast-Tamer"]]	=	{2700, -1, true,			L["Coilfang Beast-Tamer_Short"]},
	[L["Serpentshrine Sporebat"]]={2700, -1, true,		L["Serpentshrine Sporebat_Short"]},
	
	[L["Coilfang Fathom-Witch"]]={2580, -1, true,			L["Coilfang Fathom-Witch_Short"]},
	[L["Coilfang Priestess"]]		=	{2580, -1, true,			L["Coilfang Priestess_Short"]},
	[L["Coilfang Serpentguard"]]={2580, -1, true,			L["Coilfang Serpentguard_Short"]},
	[L["Coilfang Shatterer"]]			=	{2580, -1, true,		L["Coilfang Shatterer_Short"]},
	
	[L["Greyheart Nether-Mage"]]={7200, -1, true,			L["Greyheart Nether-Mage_Short"]},
	[L["Greyheart Skulker"]]		=	{7200, -1, true,			L["Greyheart Skulker_Short"]},
	[L["Greyheart Tidecaller"]]	=	{7200, -1, true,			L["Greyheart Tidecaller_Short"]},
	
	[L["Tidewalker Depth-Seer"]]={7200, -1, true,			L["Tidewalker Depth-Seer_Short"]},
	[L["Tidewalker Harpooner"]]={7200, -1, true,			L["Tidewalker Harpooner_Short"]},
	[L["Tidewalker Hydromancer"]]={7200, -1, true,		L["Tidewalker Hydromancer_Short"]},
	[L["Tidewalker Shaman"]]		=	{7200, -1, true,			L["Tidewalker Shaman_Short"]},
	[L["Tidewalker Warrior"]]		=	{7200, -1, true,			L["Tidewalker Warrior_Short"]},
}
local IncubatorHeroicTable = {

	[L["Durnholde Lookout"]]		=	{600,		-1,	true,		L["Durnholde Lookout_Short"]},
	[L["Durnholde Tracking Hound"]]	=	{600,	-1, true, 	L["Durnholde Tracking Hound_Short"]},

}
local IncubatorBossShutoff = {
	-- Table of which spawn timers a boss kill should shut off. This does not prevent the timers from being started again.
	[BB["Attumen the Huntsman"]]	=	{L["Spectral Charger"], L["Spectral Stallion"], L["Spectral Stable Hand"]},
	[BB["Moroes"]]								=	{L["Phantom Attendant"], L["Phantom Guest"], L["Phantom Valet"], L["Skeletal Waiter"]},
	[BB["Maiden of Virtue"]]			=	{L["Wanton Hostess"], L["Concubine"], L["Night Mistress"], L["Phantom Guardsman"], L["Spectral Sentry"]},
	[BB["Romulo"]]								=	{L["Skeletal Usher"], L["Phantom Stagehand"], L["Spectral Performer"]},
	[BB["Julianne"]]							=	{L["Skeletal Usher"], L["Phantom Stagehand"], L["Spectral Performer"]},
	[BB["The Big Bad Wolf"]]			=	{L["Skeletal Usher"], L["Phantom Stagehand"], L["Spectral Performer"]},
	[BB["The Crone"]]							=	{L["Skeletal Usher"], L["Phantom Stagehand"], L["Spectral Performer"]},
	[BB["The Curator"]]						=	{L["Arcane Anomaly"], L["Syphoner"], L["Arcane Watchman"]},
	[BB["Shade of Aran"]]					=	{L["Mana Feeder"], L["Arcane Watchman"], L["Arcane Protector"], L["Chaotic Sentience"], L["Mana Warp"], L["Magical Horror"], L["Spell Shade"]},
	[BB["Terestian Illhoof"]]			= {L["Homunculus"], L["Shadow Pillager"]},
	[BB["Netherspite"]]						=	{L["Spell Shade"], L["Sorcerous Shade"], L["Ethereal Thief"], L["Ethereal Spellfilcher"]},
	[BB["Prince Malchezaar"]]			= {L["Fleshbeast"], L["Greater Fleshbeast"]},
	[BB["High King Maulgar"]]			= {L["Lair Brute"], L["Gronn-Priest"]},
	[BB["Gruul the Dragonkiller"]]={L["Lair Brute"], L["Gronn-Priest"]},
	[BB["Magtheridon"]]						=	{L["Hellfire Warder"]},
	[BB["Hydross the Unstable"]]	=	{L["Underbog Colossus"], L["Coilfang Hate-Screamer"], L["Coilfang Beast-Tamer"], L["Serpentshrine Sporebat"]},
}
local IncubatorZoneList = {
	BZ["Karazhan"],
	BZ["Gruul's Lair"],
	BZ["Magtheridon's Lair"],
	BZ["Old Hillsbrad Foothills"],
	BZ["Serpentshrine Cavern"],
	BZ["Coilfang Reservoir"], -- This is here until blizzard fixes SSC returning as Coilfang Reservoir
}

local options = {
	type = 'group',
	args = {
		list = {
			type = 'execute',
			name = L["List running timers"],
			desc = L["Output all active timers to chat"],
			func = function()
				Incubator:ConsoleRunning()
			end,
		},
		maxshowtime = {
			type = 'range',
			name = L["Maximum time in minutes"],
			desc = L["Set the maximum time for a respawn bar to show"],
			get = function()
				return Incubator.db.profile.maxshowtime
			end,
			set = function(v)
				Incubator.db.profile.maxshowtime = v
			end,
			min = 0,
			max = 120,
			step = 1,
		},
		barcount = {
			type = 'range',
			name = L["Bar count"],
			desc = L["Maximum number of bars to show at one time"],
			get = function()
				return Incubator.db.profile.barcount
			end,
			set = function(v)
				Incubator.db.profile.barcount = v
			end,
			min = 0,
			max = 25,
			step = 1,
		},
		timebetween = {
			type = 'range',
			name = L["Time between bars"],
			desc = L["Only show bars that are further apart then this in minutes"],
			get = function()
				return Incubator.db.profile.timebetween
			end,
			set = function(v)
				Incubator.db.profile.timebetween = v
			end,
			min = 0,
			max = 30,
			step = 1,
		},
		developer = {
			type = 'toggle',
			name = L["Developer"],
			desc = L["Outputs debug information to chat"],
			get = function()
				return Incubator.db.profile.developer
			end,
			set = function(v)
				Incubator.db.profile.developer = v
			end,
			map = { [false] = L["Disabled"], [true] = L["Enabled"] },
		},
		baroptions = {
			type = 'group',
			desc = 'bar options',
			name = L["Bar Options"],
			args = {
				enablemouse = {
					type = 'toggle',
					name = L["Enable Mouse"],
					desc = L["Enable mouse interaction on bars"],
					get = function()
						return Incubator.db.profile.baroptions.enablemouse
					end,
					set = function(v)
						Incubator.db.profile.baroptions.enablemouse = v
					end,
					map = { [false] = L["Disabled"], [true] = L["Enabled"] },
				},
				locked = {
					type = 'toggle',
					name = L["Locked"],
					desc = L["Lock the bars, preventing dragging"],
					get = function()
						return Incubator.db.profile.baroptions.locked
					end,
					set = function(v)
						Incubator.db.profile.baroptions.locked = v
						Incubator:ToggleLock()
					end,
					map = { [false] = L["Disabled"], [true] = L["Enabled"] },
				},
				growup = {
					type = 'toggle',
					name = L["Grow up"],
					desc = L["Grow bars upward from the anchor"],
					get = function()
						return Incubator.db.profile.baroptions.growup
					end,
					set = function(v)
						Incubator.db.profile.baroptions.growup = v
					end,
					map = { [false] = L["False"], [true] = L["True"] },
				},
				texture = {
						type = "text",
						name = L["Texture"],
						desc = L["Incubator bar texture"],
						get = function() 
							return Incubator.db.profile.baroptions.texture 
						end,
						set = function(v)
							Incubator.db.profile.baroptions.texture = v
						end,
						validate = surface:List(),
				},
				barwidth = {
					type = 'range',
					name = L["Bar width"],
					desc = L["Width of Incubator bars"],
					get = function()
						return Incubator.db.profile.baroptions.width
					end,
					set = function(v)
						Incubator.db.profile.baroptions.width = v
					end,
					min = 24,
					max = 512,
					step = 8,
				},
				barheight = {
					type = 'range',
					name = L["Bar height"],
					desc = L["Width of Incubator bars"],
					get = function()
						return Incubator.db.profile.baroptions.height
					end,
					set = function(v)
						Incubator.db.profile.baroptions.height = v
					end,
					min = 6,
					max = 64,
					step = 2,
				},
				barscale = {
					type = 'range',
					name = L["Bar scale"],
					desc = L["Scale of Incubator bars"],
					get = function()
						return Incubator.db.profile.baroptions.scale
					end,
					set = function(v)
						Incubator.db.profile.baroptions.scale = v
					end,
					min = 0.5,
					max = 1.5,
					step = 0.1,
				},
			},
		},
	},
}

Incubator = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "CandyBar-2.0")
Incubator:RegisterChatCommand(L["Slash-Commands"], options)
Incubator:RegisterDB("IncubatorDB", "IncubatorDBPC")
Incubator:RegisterDefaults("profile", {
	maxshowtime = 60,
	barcount = 5,
	timebetween = 0,
	developer = false,
	
	x = 0,
	y = 0,
	relpoint = "CENTER",
	point = "CENTER",
	["baroptions"] = {
		["enablemouse"] = true,
		["locked"] = false,
		["growup"] = false,
		["colors"] = { "blue", "green", "red", },
		["width"] = 128,
		["height"] = 16,
		["scale"] = 1.0,
		["texture"] = "BantoBar",
	},
} )

function Incubator:CreateAnchor()
	self.anchor = CreateFrame("Frame",anchor..tostring(math.floor(GetTime())),UIParent)
	self.anchor:ClearAllPoints();
	self.anchor:SetBackdrop( {
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16, insets = {
			left = 5, right = 5, top = 5, bottom = 5 },
	} );
	self.anchor:SetWidth(128)
	self.anchor:SetHeight(30)
	self.anchor:SetBackdropColor(0.1,0.1,0.3)
	self.anchor:EnableMouse(Incubator.db.profile.baroptions.enablemouse)
	self.anchor:SetPoint(Incubator.db.profile.point, "UIParent", Incubator.db.profile.relpoint, Incubator.db.profile.x, Incubator.db.profile.y)
	local msg = self.anchor:CreateFontString(nil,"overlay","GameFontNormal")
	msg:ClearAllPoints()
	msg:SetPoint("CENTER", self.anchor, "CENTER")
	msg:SetText(anchor)
	self.anchor:SetMovable(true)
	self.anchor:SetScript("OnDragStart", function() self.anchor:StartMoving(); GameTooltip:Hide() end)
	self.anchor:SetScript("OnDragStop", function() self.anchor:StopMovingOrSizing(); self:SavePosition() end)
	self.anchor:SetScript("OnMouseUp", function() self:OnAnchorClick() end)
	self.anchor:SetScript("OnEnter", function() self:ShowAnchorTooltip() end)
	self.anchor:SetScript("OnLeave", function() GameTooltip:Hide() end)
	self.anchor:RegisterForDrag("LeftButton")
	if Incubator.db.profile.baroptions.locked then
		self.anchor:Hide()
	else
		self.anchor:Show()
	end
	self:RegisterCandyBarGroup(anchor)
	self:SetCandyBarGroupPoint(anchor, "TOP", self.anchor:GetName(), "BOTTOM", 0, 0)
	self:SetCandyBarGroupGrowth(anchor, Incubator.db.profile.baroptions.growup)
end

	
function Incubator:LockAnchor()
	Incubator.db.profile.baroptions.locked = true
	self.anchor:Hide()
end

function Incubator:UnlockAnchor()
	Incubator.db.profile.baroptions.locked = false
	self.anchor:Show()
end

function Incubator:ToggleLock()
	if Incubator.db.profile.baroptions.locked then
		self.anchor:Hide()
	else
		self.anchor:Show()
	end
end

function Incubator:ShowAnchorTooltip()
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT")
	GameTooltip:AddLine(L["Incubator Anchor"])
	GameTooltip:AddLine(L["Drag this to reposition Incubator bars"])
	GameTooltip:AddLine(L["Alt+Left Click will display or hide a test bar"])
	GameTooltip:AddLine(L["Shift+Left Click will lock and hide the anchor"])
	GameTooltip:Show()
end

function Incubator:OnAnchorClick()
	if IsAltKeyDown() then
		if self:IsCandyBarRegistered("Incubator Testbar") then
			self:StopCandyBar("Incubator Testbar")
			return;
		end
		self:RegisterCandyBar("Incubator Testbar", 300, "Test bar", nil, unpack(Incubator.db.profile.baroptions.colors) )
		self:RegisterCandyBarWithGroup("Incubator Testbar", anchor)
		self:SetCandyBarTexture("Incubator Testbar", surface:Fetch(Incubator.db.profile.baroptions.texture))
		self:SetCandyBarWidth("Incubator Testbar", Incubator.db.profile.baroptions.width)
		self:SetCandyBarHeight("Incubator Testbar", Incubator.db.profile.baroptions.height)
		self:SetCandyBarScale("Incubator Testbar", Incubator.db.profile.baroptions.scale)
		self:StartCandyBar("Incubator Testbar", true)
	end
	if IsShiftKeyDown() then
		if self:IsCandyBarRegistered("Incubator Testbar") then
			self:StopCandyBar("Incubator Testbar")
			return;
		end
		Incubator:LockAnchor()
	end
end

function Incubator:SavePosition()
	Incubator.db.profile.point, _, Incubator.db.profile.relpoint, Incubator.db.profile.x, Incubator.db.profile.y = Incubator.anchor:GetPoint()
end

local metro = AceLibrary("Metrognome-2.0")

function Incubator:OnEnable()
	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	
	metro:RegisterMetro("CombatHandler", self.TimerHandler, INCUBATOR_OOC_THRESHOLD)
	metro:RegisterMetro("PeriodicHandler", self.PeriodicHandler, 1)
	metro:Start("PeriodicHandler")
	
	surface:Register("Blizzard", "Interface\\TargetingFrame\\UI-StatusBar")
	surface:Register("BantoBar", "Interface\\AddOns\\Incubator\\textures\\bantobar.tga")
	surface:Register("Charcoal", "Interface\\AddOns\\Incubator\\textures\\charcoal.tga")
	surface:Register("Otravi", "Interface\\AddOns\\Incubator\\textures\\otravi.tga")
	surface:Register("Perl", "Interface\\AddOns\\Incubator\\textures\\perl.tga")
	surface:Register("Smooth", "Interface\\AddOns\\Incubator\\textures\\smooth.tga")
	surface:Register("Smudge", "Interface\\AddOns\\Incubator\\textures\\smudge.tga")
	surface:Register("Striped", "Interface\\AddOns\\Incubator\\textures\\striped.tga")
	
	self:CreateAnchor()
end

function Incubator:PLAYER_ENTERING_WORLD()
	-- reset existing timers, etc
end

function Incubator:CHAT_MSG_COMBAT_HOSTILE_DEATH(msg)
	-- increment a death counter and start timers if needed
	if Incubator:InTrackedZone() then
		for key, table in pairs(IncubatorTable) do
			if msg == string.format(UNITDIESOTHER, key) then
			-- The thing that died is on our list of stuff that can be tracked.
			CurrentCombat[key] = 1
				if Killcount[key] == nil then
					Killcount[key] = 1
				else
					Killcount[key] = Killcount[key] + 1
				end
				if Incubator.db.profile.developer == true then
					Incubator:Print(key, "found on list to be tracked.", Killcount[key], "this combat.")
				end
			end
		end
		
		for key, value in pairs(IncubatorBossShutoff) do
			if msg == string.format(UNITDIESOTHER, key) then
			-- A boss died, so kill all the timers associated with that boss.
				Incubator:BossDeath(key)
			end
		end
	end
end


function Incubator:PLAYER_REGEN_DISABLED()
	InCombat = true
	metro:Stop("CombatHandler") 
end

function Incubator:InTrackedZone()
	local currentzone = GetRealZoneText()
	for n, zone in pairs(IncubatorZoneList) do
		if zone == currentzone then
			return true
		end
	end
	return false
end

function Incubator:BossDeath(BossName)
	if BossName == BB["Romulo"] or key == BB["Julianne"] then
		--need a special handler for R&J since they both die twice.
	else
		for tindex, mobname in pairs(IncubatorBossShutoff[BossName]) do
			for timername, timerlist in pairs (RunningTimers) do
				if string.find(timername, IncubatorTable[mobname][4]) == 1 then
					if RunningTimers[timername][3] == false then-- candybar was started on this one
						self:StopCandyBar("Incubator-"..timername)
						BarCount = BarCount - 1
					end
					RunningTimers[timername][1] = nil
					RunningTimers[timername][2] = nil
					RunningTimers[timername][3] = nil
					RunningTimers[timername] = nil
				end
			end
			IncubatorTable[mobname] = nil -- Prevent new bars from being started on this mob
		end
	end
	
	if BossName == BB["The Curator"] then
		IncubatorTable[L["Arcane Watchman"]] = {7200, 2, false, L["Arcane Watchman_Short"]}
	end
	
	if BossName == BB["Shade of Aran"] then
		IncubatorTable[L["Spell Shade"]] = {7200, -1, true, L["Spell Shade_Short"]}
	end
	
	if BossName == BB["High King Maulgar"] then
		IncubatorTable[L["Lair Brute"]] = {3600, -1,	true, L["Lair Brute_Short"]}
		IncubatorTable[L["Gronn-Priest"]] = {3600, -1,	true, L["Gronn-Priest_Short"]}
	end
end

function Incubator:PLAYER_REGEN_ENABLED()
		LastOOC = GetTime()
		metro:Start("CombatHandler") -- starting bars (set AllowTimers to false) if less than the ooc threshold (hopefully a fix for vanish/FD)
		if Incubator.db.profile.developer == true then
			Incubator:Print("Starting OOC timer")
		end
end

function Incubator:StartTimer(name, duration)
	local counter = 1
	local expiration = duration + LastOOC
	local title = name .. tostring(counter)
--	for key, value in pairs(RunningTimers) do
--		if string.find(key, name) and RunningTimers[key][1] ~= nil then
--			counter = tonumber(string.sub(key, string.len(name)+1))+1
--		end
--	end
	
	while RunningTimers[title] ~= nil do
		counter = counter + 1
		title = name .. tostring(counter)
	end
	
	
	RunningTimers[title] = { expiration, true, true }
	if Incubator.db.profile.developer == true then
		Incubator:Print("Starting timer named", title, (SecondsToTime(duration)))
	end
end

function Incubator:TimerHandler()
	-- handles all the timers that need to be started and clearing out the current combat list
	if Incubator.db.profile.developer == true then
		Incubator:Print("Processing Timers")
	end
	local StartedNonHomogeneous = false -- Flag to indicate that we already started a timer on a pack
	metro:Stop("CombatHandler")
	InCombat = false
	for key, value in pairs(CurrentCombat) do
		if value == 1 then
			if Killcount[key] >= IncubatorTable[key][2] then
				if IncubatorTable[key][3] == true and StartedNonHomogeneous == false then
					StartedNonHomogeneous = true
					-- Start a timer on this particular mob. We only want to start the timer on this one instead of 2+ mobs with the same timer.
					Incubator:StartTimer(IncubatorTable[key][4], IncubatorTable[key][1])
				end
				if IncubatorTable[key][3] == false then
				-- Start a timer on that mob, enough of them died. These are solo so we don't care about other deaths.
					Incubator:StartTimer(IncubatorTable[key][4], IncubatorTable[key][1])
				end
				Killcount[key] = nil
			else
				if Incubator.db.profile.developer == true then
					Incubator:Print("Discarding info on", key, "(Got", Killcount[key], "needed", IncubatorTable[key][2], ")")
				end
				Killcount[key] = nil
			end
		end
		CurrentCombat[key] = nil
	end
end

function Incubator:PeriodicHandler()
	local threshold = Incubator.db.profile.barcount
	if threshold == 0 then
		threshold = 999
	end
	local showthreshold = Incubator.db.profile.maxshowtime
	if showthreshold == 0 then
		showthreshold = 999
	end
	for key, value in pairs(RunningTimers) do
		--[[ RunningTimers format is 
			RunningTimers[Timername]
				[1] = expiration time
				[2] = Warning needs to be given
				[3] = Bar needs to be started
		]]--
		if GetTime() + 600 > RunningTimers[key][1] and RunningTimers[key][2] and Incubator.db.profile.developer then
			local remaining = floor(RunningTimers[key][1] - GetTime())
			Incubator:Print(key, "respawns in", remaining)
			RunningTimers[key][2] = false
		end
		
		if GetTime() + (60 * showthreshold) > RunningTimers[key][1] and RunningTimers[key][3] and BarCount < threshold and (RunningTimers[key][1] - Lastexp) > (Incubator.db.profile.timebetween * 60) then
			Incubator:RegisterCandyBar("Incubator-"..key, floor(RunningTimers[key][1] - GetTime()), key, nil, unpack(Incubator.db.profile.baroptions.colors))
			Incubator:RegisterCandyBarWithGroup("Incubator-"..key, anchor)
			Incubator:SetCandyBarTexture("Incubator-"..key, surface:Fetch(Incubator.db.profile.baroptions.texture))
			Incubator:SetCandyBarWidth("Incubator-"..key, Incubator.db.profile.baroptions.width)
			Incubator:SetCandyBarHeight("Incubator-"..key, Incubator.db.profile.baroptions.height)
			Incubator:SetCandyBarScale("Incubator-"..key, Incubator.db.profile.baroptions.scale)
			Incubator:SetCandyBarOnClick("Incubator-"..key, OnBarClick, key)
			Incubator:StartCandyBar("Incubator-"..key, true)
			RunningTimers[key][3] = false
			BarCount = BarCount + 1
			Lastexp = RunningTimers[key][1]
		end
		
		if GetTime() > RunningTimers[key][1] then
			if RunningTimers[key][1] == Lastexp then
				Lastexp = 0
			end
		RunningTimers[key][1] = nil
		RunningTimers[key][2] = nil
		RunningTimers[key][3] = nil
		RunningTimers[key] = nil
		BarCount = BarCount - 1
		end
	end
end

function Incubator:ConsoleRunning()
	for key, value in pairs(RunningTimers) do
		Incubator:Print(key, (SecondsToTime(floor(RunningTimers[key][1] - GetTime()))))
	end
end

function Incubator:OnBarClick(name)
	if IsCtrlKeyDown() then
		if UnitInRaid("player") == nil then
		SendChatMessage(name .. SecondsToTime(floor(RunningTimers[name][1] - GetTime())), PARTY)
		else
		SendChatMessage(name .. SecondsToTime(floor(RunningTimers[name][1] - GetTime())), RAID)
		end
	end
	if IsShiftKeyDown() then
		self:StopCandyBar("Incubator-"..name)
		if RunningTimers[key][1] == Lastexp then
			Lastexp = 0
		end
		RunningTimers[name][1] = nil
		RunningTimers[name][2] = nil
		RunningTimers[name][3] = nil
		RunningTimers[name] = nil
		BarCount = BarCount - 1
		Incubator:Print("Clearing timer", name)
	end
end

function Incubator:InCombat()
	if UnitAffectingCombat("player") == nil then
		if UnitInRaid("player") == nil then
			local n = GetNumPartyMembers()
			if n == 0 then
				return false
			else
				for i = 1, n do
					if UnitAffectingCombat("party" .. i) == 1 then
						return true
					end
				end
				return false
			end
		else
			local n = GetNumRaidMembers()
			for i = 1, n do
				if UnitAffectingCombat("raid" .. i) == 1 then
					return true
				end
			end
			return false
		end
	else
		return true
	end
end
